﻿using SimpleJSON;
using System;
using System.Collections;
using System.Linq;
using UnityEngine;

// TODO
// - Finetune - not much more
// - Package up and test
// - Look for other sim values in params - what do they do?
// - What does "integrateEnabled" mean in sim storables? Has something to do with being connected to model - not sure of its use
// - Clean up directories of files that are no longer needed
// - convert png to jpg where possible
// - Static cum on collisions / post-events with long fade-out - convert these cloth items to use textures already in use
// - Cum colliders that originate at cum event and fall down onto female body and hopefully trigger other events
// - Improve code quality - review patterns, refactor, restructure, etc
// - Review all sim textures and carefully adjust if necessary
// - Add Detach threshold and possibly drag/dripdrag to advanced config
// - Auto actions should be linked with storable actions. Or another solution found so that API doesn't mess with auto-state
// - Maybe refactor auto-state (re above)
// - Add configurable triggers for auto-interactions

namespace AwasAutoJuice {
    internal class AwasFluids : MVRScript {

        private AwasFluidPlateCollider headFluidCollider;
        private AwasActionConfigurationRepository actionsConfigRepository;
        private bool isLoadingConfig = false;
        AwasFluidBodyTriggerService fluidBodyTriggerService;

        public override void Init() {
            try {
                DAZCharacterSelector containingAtomCharacterGeom = containingAtom.GetStorableByID("geometry") as DAZCharacterSelector;
                DAZCharacterSelector.Gender containingAtomGender = containingAtomCharacterGeom != null ? containingAtomCharacterGeom.gender : DAZCharacterSelector.Gender.None;
                bool isFemale = containingAtomGender == DAZCharacterSelector.Gender.Female;

                actionsConfigRepository = new AwasActionConfigurationRepository(isFemale);

                StartCoroutine(DeferredLoad());
                StartCoroutine(SetupFluids(isFemale));
            } catch (Exception e) {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        private IEnumerator SetupFluids(bool isFemale) {
            // In a deferred load situation, need to wait until singleton loading has completed before 
            // continuing
            while (SuperController.singleton.isLoading) {
                yield return 0;
                if (this == null) yield break;
            }

            Logger.Debug("SetupFluids");

            AwasFluidClothingService clothingService = new AwasFluidClothingService(containingAtom, isFemale);
            AwasFluidActionService actionFactory = new AwasFluidActionService(this, clothingService, actionsConfigRepository);

            FreeControllerV3 pTipController = containingAtom.freeControllers.First(rb => rb.name == "penisTipControl");
            FreeControllerV3 pelvisController = containingAtom.freeControllers.First(rb => rb.name == "pelvisControl");
            FreeControllerV3 headController = containingAtom.freeControllers.First(rb => rb.name == "headControl");

            yield return new WaitUntil(() => clothingService.IsAllClothingReady());
            Logger.Debug("clothingService.IsAllClothingReady");

            if (!isFemale) {
                // TODO add male action bool APIs
                AwasUserUiAction jizz = actionFactory.CreateJizzAction(pTipController);
                AwasUserUiAction stickyjizz = actionFactory.CreateJizzStickyAction();
                AwasUserUiAction mouthJizz = actionFactory.CreateJizzOnMouthAction(pTipController);
                AwasUserUiAction jizzInMouth = actionFactory.CreateJizzInMouthAction(pTipController);
                AwasUserUiAction wetPenis = actionFactory.CreateWetPenisToggleAction();
                AwasUserUiAction wetPenisTip = actionFactory.CreateWetPenisTipToggleAction();
                AwasUserUiAction wetPenisCum = actionFactory.CreateWetPenisCumToggleAction();

                wetPenis.CreateUIButton("Wet Penis toggle");
                wetPenisTip.CreateUIButton("Wet Penis Tip toggle");
                wetPenisCum.CreateUIButton("Penis Covered in Cum toggle");
                jizz.CreateUIButton("Jizz");
                stickyjizz.CreateUIButton("Sticky jizz");
                mouthJizz.CreateUIButton("Jizz on Mouth");
                jizzInMouth.CreateUIButton("Jizz in Mouth");
            }

            if (isFemale) {
                try {
                    //headFluidCollider = new AwasFluidPlateCollider(0.1f);
                    // Testing a collider to push fluid to front
                    //JSONStorable headSt = containingAtom.GetComponentInParent<Atom>().GetStorableByID("head");
                    //Rigidbody headRigidBody = headSt.GetComponent<Rigidbody>();
                    //headFluidCollider.Debug();
                    //headFluidCollider.SetTransformWithOffset(headRigidBody.transform, (headRigidBody.transform.up * 0.02f) + (headRigidBody.transform.forward * 0.05f));
                    //headFluidCollider.SetParent(headRigidBody.transform);
                } catch (Exception e) {
                    SuperController.LogError(e.Message);
                }

                AwasUserUiAction wetPussy = actionFactory.CreateWetPussyToggleAction();
                AwasUserUiAction wetPussyJuicy = actionFactory.CreateWetPussyJuicyToggleAction();
                AwasUserUiAction pussyFullOfCum = actionFactory.CreatePussyFullOfCumToggleAction();
                AwasUserUiAction wetPussyDrip = actionFactory.CreateWetPussyDripAction();
                AwasUserUiAction pussyCumDrip = actionFactory.CreatePussyCumDripAction();
                AwasUserUiAction mouthFullOfCum = actionFactory.CreateCumInMouthToggleAction();
                AwasUserUiAction mouthCumDrip = actionFactory.CreateMouthCumDripAction();
                AwasUserUiAction mouthCumSticky = actionFactory.CreateMouthCumStickyToggleAction();
                AwasUserUiAction neckCumDrip = actionFactory.CreateNeckCumDripAction(); 

                wetPussy.CreateUIButton("Wet Pussy toggle");
                wetPussyJuicy.CreateUIButton("Wet Juicy Pussy toggle");
                pussyFullOfCum.CreateUIButton("Pussy full of cum toggle");
                wetPussyDrip.CreateUIButton("Wet Pussy Drip");
                pussyCumDrip.CreateUIButton("Pussy Cum Drip");
                mouthFullOfCum.CreateUIButton("Mouth Full of Cum toggle");
                mouthCumDrip.CreateUIButton("Mouth Cum Drip");
                mouthCumSticky.CreateUIButton("Sticky Mouth Cum toggle");
                neckCumDrip.CreateUIButton("Neck Cum Drip");
            }
            AwasAutoJuiceUi pluginUi = new AwasAutoJuiceUi(this, actionsConfigRepository);
            if (RunMode.isDev) {
                CreateButton("Copy action values to clipboard").button.onClick.AddListener(() => {
                    var configJson = pluginUi.GetJSONForCurrentSelectedActionConfig();
                    var configJsonString = configJson.ToString();
                    configJsonString = configJsonString.Replace(":", " = ");
                    configJsonString = configJsonString.Replace("\"", "");
                    configJsonString = configJsonString.Replace(",", "f,\n");                    
                    // This isn't an error                    
                    GUIUtility.systemCopyBuffer = configJsonString;
                });
            }

            fluidBodyTriggerService = new AwasFluidBodyTriggerService(containingAtom, isFemale, actionFactory);
            fluidBodyTriggerService.SetActive(true);
            pluginUi.CreateMainUiToggle("Automatic Fluid Triggers", true, false, (bool isEnabled) => {
                fluidBodyTriggerService.SetActive(isEnabled);
            });
            pluginUi.CreateMainUIButton("Restore Action Settings to Default", false, () => {
                SuperController.singleton.Alert("Warning! Restoring Auto Juice settings will destroy any changes you have made in this scene.", 
                    () => {
                        actionsConfigRepository.RestoreFactoryDefaults();
                        pluginUi.UpdateCurrentlySelectedActionUi();
                    }, 
                    null);
            });
            pluginUi.CreateMainUiToggle("Dev Mode", false, false, (bool isDevMode) => {
                RunMode.isDev = isDevMode;
            });

            yield return null;
        }

        #region Detail classes

        #endregion

        void OnDestroy() {
            if (headFluidCollider != null) {
                headFluidCollider.Remove();
            }
            if (fluidBodyTriggerService != null) {
                fluidBodyTriggerService.SetActive(false);
                fluidBodyTriggerService.RemoveAllTriggersAndHandlers();
            }
        }

        #region Boring
        // Allow reloading configuration from JSON on plugin reload?
        private IEnumerator DeferredLoad() {
            yield return new WaitForEndOfFrame();
            if (this == null) yield break;

            // In a deferred load situation, need to wait until singleton loading has completed before 
            // continuing
            while (SuperController.singleton.isLoading) {
                yield return 0;
                if (this == null) yield break;
            }

            Logger.Debug("DeferredLoad");
            base.containingAtom.RestoreFromLast(this);
        }

        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false) {
            JSONClass jsonClass = base.GetJSON(includePhysical, includeAppearance, forceStore);
            try {
                needsStore = true;
                JSONArray actionsConfigJson = actionsConfigRepository.GetJSON();
                jsonClass["actionsConfig"] = actionsConfigJson;
                jsonClass["version"] = "1";
            } catch (Exception e) {
                SuperController.LogError($"AwasFluids GetJSON exception: {e}");
            }

            return jsonClass;
        }

        public override void RestoreFromJSON(JSONClass jsonClass, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true) {
            base.RestoreFromJSON(jsonClass, restorePhysical, restoreAppearance, presetAtoms, setMissingToDefault);
            try {
                var actionsConfig = jsonClass["actionsConfig"];
                var version = jsonClass["version"];

                LoadConfig(actionsConfig.AsArray);
                return;
            } catch (Exception e) {
                SuperController.LogError($"AwasFluids RestoreFromJSON exception: {e}");
            } 
        }

        private void LoadConfig(JSONArray actionsConfig) {
            if (isLoadingConfig) return;
            isLoadingConfig = true;
            
            try {
                actionsConfigRepository.RestoreFromJSON(actionsConfig);
            } catch (Exception e) {
                SuperController.LogError($"AwasFluids LoadConfig exception: {e}");
            } finally {
                isLoadingConfig = false;
            }
        }
    #endregion
    }

    internal static class RunMode {
        public static bool isDev = false;
    }

    #region Other stuff

    internal class Logger {

        public static void Debug(string message) {
            if (RunMode.isDev) SuperController.LogMessage($"{DateTime.Now} {DateTime.Now.Millisecond} : {message}");
        }

        private string context = "";
        public Logger(string context) {
            this.context = context;
        }

        public void ContextDebug(string message) {
            Debug($"[{context}] {message}");
        }
    }
    
    public class TriggerEventArgs : EventArgs {
        public Collider collider { get; set; }
        public string evtType { get; set; }
    }

    public class CollideEventArgs : EventArgs {
        public Collision collision { get; set; }
        public string evtType { get; set; }
    }

    public class STriggerCollide : MonoBehaviour {
        TriggerEventArgs lastTriggerEvent;
        CollideEventArgs lastCollideEvent;

        public event EventHandler<TriggerEventArgs> OnTrigger;
        public event EventHandler<CollideEventArgs> OnCollide;
        private float lastStayTime = 0;
        private float stayDelta { get { return Time.time - lastStayTime; } }

        void Awake() {
            lastTriggerEvent = new TriggerEventArgs {
                evtType = "none",
                collider = null
            };

            lastCollideEvent = new CollideEventArgs {
                evtType = "none",
                collision = null
            };
        }

        public void Clear() {
            OnTrigger = null;
            OnCollide = null;
        }

        private void OnTriggerEnter(Collider other) {
            DoTriggerEvent("Entered", other);
        }

        private void OnTriggerExit(Collider other) {
            DoTriggerEvent("Exited", other);
        }

        private void OnTriggerStay(Collider other) {
            if (stayDelta < 0.2f) return;
            DoTriggerEvent("Stay", other);
            lastStayTime = Time.time;
        }

        private void OnCollisionEnter(Collision collision) {
            DoCollisionEvent("CEntered", collision);

        }

        private void OnCollisionExit(Collision collision) {
            DoCollisionEvent("CExited", collision);
        }

        private void DoTriggerEvent(string evtType, Collider col) {
            if (string.Equals(evtType, lastTriggerEvent.evtType) && col.gameObject == lastTriggerEvent.collider.gameObject) {
                return;
            } else {
                TriggerEventArgs tempEvent = new TriggerEventArgs {
                    collider = col,
                    evtType = evtType
                };
                OnTriggerEvent(tempEvent);
                lastTriggerEvent = tempEvent;
            }
        }

        private void DoCollisionEvent(string evtType, Collision col) {
            if (string.Equals(evtType, lastCollideEvent.evtType) && col.gameObject == lastCollideEvent.collision.gameObject) {
                return;
            } else {
                CollideEventArgs tempEvent = new CollideEventArgs {
                    collision = col,
                    evtType = evtType
                };
                OnCollideEvent(tempEvent);
                lastCollideEvent = tempEvent;
            }
        }

        protected virtual void OnTriggerEvent(TriggerEventArgs e) {
            EventHandler<TriggerEventArgs> handler = OnTrigger;
            handler?.Invoke(this, e);
        }

        protected virtual void OnCollideEvent(CollideEventArgs e) {
            EventHandler<CollideEventArgs> handler = OnCollide;
            handler?.Invoke(this, e);
        }

    }
    #endregion
}
