﻿using System;
using System.Collections;

namespace AwasAutoJuice {
    internal class AwasFluidAtomFactory {
        string id;
        string clothName;

        public AwasFluidAtomFactory(string containingAtomId, string fluidClothName) {
            id = containingAtomId;
            clothName = fluidClothName;
        }

        public IEnumerator CreateNewGrabSphere(Action<AwasFluidGrabSphere> assignAtom) {
            string guid = Guid.NewGuid().ToString();
            string grabSphereUid = $"awas.fluidGrabSphere.{id}.{clothName}.{guid}";
            yield return SuperController.singleton.AddAtomByType("ClothGrabSphere", grabSphereUid);
            Atom clothGrabSphere = SuperController.singleton.GetAtomByUid(grabSphereUid);
            clothGrabSphere.GetStorableByID("scale").SetFloatParamValue("scale", 0.2f);
            AwasFluidGrabSphere awasGrabSphere = new AwasFluidGrabSphere(clothGrabSphere);
            assignAtom(awasGrabSphere);
        }

        public IEnumerator CreateNewSphere(Action<AwasFluidSphere> assignAtom) {
            string guid = Guid.NewGuid().ToString();
            string sphereUid = $"awas.fluidSphere.{id}.{clothName}.{guid}";
            yield return SuperController.singleton.AddAtomByType("Sphere", sphereUid);
            Atom atomSphere = SuperController.singleton.GetAtomByUid(sphereUid);
            atomSphere.GetStorableByID("scale").SetFloatParamValue("scale", 0.2f);
            AwasFluidSphere awasSphere = new AwasFluidSphere(atomSphere);
            assignAtom(awasSphere);
        }
    }
}
