﻿using UnityEngine;

namespace AwasAutoJuice {
    internal class AwasFluidGrabSphere {
        private Atom grabSphere;
        private Transform originalTransformParent;
        private Transform originalControlTransformParent;

        public AwasFluidGrabSphere(Atom grabSphereAtom) {
            grabSphere = grabSphereAtom;
            originalTransformParent = grabSphere.transform.parent;
            originalControlTransformParent = grabSphere.mainController.transform.parent;
        }

        public void SetScale(float scale) {
            grabSphere.GetStorableByID("scale").SetFloatParamValue("scale", scale);
        }

        public void On() {
            grabSphere.SetOn(true);
        }

        public void Off() {
            grabSphere.SetOn(false);
        }

        public void SetTransformWithOffset(Transform transform, Vector3 offset) {
            grabSphere.transform.SetPositionAndRotation(transform.position + offset, transform.rotation);
            grabSphere.mainController.transform.SetPositionAndRotation(transform.position + offset, transform.rotation);
        }

        public void SetPosition(Vector3 newPosition) {
            grabSphere.transform.position = newPosition;
            grabSphere.mainController.transform.position = newPosition;
        }

        public void SetNewParent(Transform newParent) {
            grabSphere.transform.SetParent(newParent);
            grabSphere.mainController.transform.SetParent(newParent);
        }

        public void Remove() {
            try {
                RestoreOriginalParent();
                SuperController.singleton.RemoveAtom(grabSphere);
            } catch { }
        }

        private void RestoreOriginalParent() {
            grabSphere.transform.SetParent(originalTransformParent);
            grabSphere.mainController.transform.SetParent(originalControlTransformParent);
        }

        public Transform GetTransform() {
            return grabSphere.transform;
        }
    }
}
